import { Result } from "@repo/rdx-utils";
import { z } from "zod/v4";
import { translateZodValidationError } from "../helpers";
import { ValueObject } from "./value-object";

interface StreetProps {
  value: string;
}

export class Street extends ValueObject<StreetProps> {
  private static readonly MAX_LENGTH = 255;

  protected static validate(value: string) {
    const schema = z
      .string()
      .trim()
      .max(Street.MAX_LENGTH, {
        message: `Street must be at most ${Street.MAX_LENGTH} characters long`,
      });
    return schema.safeParse(value);
  }

  static create(value: string) {
    const valueIsValid = Street.validate(value);

    if (!valueIsValid.success) {
      return Result.fail(translateZodValidationError("Street creation failed", valueIsValid.error));
    }
    return Result.ok(new Street({ value }));
  }

  getProps(): string {
    return this.props.value;
  }

  toPrimitive() {
    return this.getProps();
  }

  toString() {
    return String(this.props.value);
  }
}
